# Getting started


1. Create a group for the team in JYU Gitlab, and add other team members <https://gitlab.jyu.fi/groups/new>
2. Fork template repository <https://gitlab.jyu.fi/startuplab/courses/tjts5901-continuous-software-engineering/tjts5901-dogmap_template/-/forks/new>. Keep it public.
3. Setup local development environment
   1. Install visual studio code
   2. Install docker (fallback to anaconda3)
   3. Clone your project repository to local
   4. Open cloned folder in visual studio code
   5. install require dependencies (in vscode terminal. top menu -> terminal -> new terminal: `pip install --user -r requirements.txt`)
   6. Run app (either from terminal, or top menu -> run -> start debugging)
   7. Open in browser <http://127.0.0.1:5000/>
4. (Create Azure resource group)
5. Create either Kubernetes cluster or virtual machine, and install gitlab runner
6. Create docker container registry
7. (Create docker image and push to the container registry)
8. Create Web App
9. Setup gitlab pipeline variables
10. Test by changing something, and see if changes are deployed automatically.

If you run into a problem, check if there is "fix" in reference implementation. <https://gitlab.jyu.fi/startuplab/courses/tjts5901-continuous-software-engineering/tjts5901-dogmap_template/-/commits/main/>. If you spot a mistake, error/bug, you can send a pull request for a fix for kudos and fame.

## Overview of the technology stack

![CI/CD overview. Reference: Vehent J 2018, Securing DevOps, Figure 2.1.](CICDdrawio.png)

### Development

1. **Source code** resides in git. Git is a distributed source code management system named after its creator, Linus Torvalds. It's utilised by everyone, even by University of Jyväskylä teaching staff (since 2019-ish). Guide for git provided by Vesa Lappalainen is available at <https://tim.jyu.fi/view/kurssit/tie/ohj1/harjoitustyo/git>. And other places.

2. **Coding** can be done with your favourite tool, but [visual studio code](https://code.visualstudio.com/) is recommended for it's versatility and popularity. Please note that the "code" version is different of what you might have installed on Ohj1.

3. **Backend code** is done using Python and [Flask](https://flask.palletsprojects.com/en/2.0.x/) framework. [TIES4080 Web-palvelinohjelmointi](https://appro.mit.jyu.fi/ties4080/) uses similar tools and setup.

4. **Frontend code** is html and javascript. [TIEA2120 Web-käyttöliittymien ohjelmointi](https://appro.mit.jyu.fi/tiea2120/) uses similar tools and setup. For mapping api we'll use [Leaflet](https://leafletjs.com/).

5. **Database** is MongoDB. Sadly [universitys' course for databases](https://opinto-opas.jyu.fi/2021/fi/opintojakso/itka2004/) is not applicable here at all, as it focuses on ACID databases and we'll use BASE.

6. **Containerization** is provided by [Docker](http://docker.com/). It's supported on Windows (from Windows 10 onwards), Linux and Mac. Containers are kinda like virtual machines, but not really - just different namespaces from underlying operating systems. [Univesity of Helsinki provides Mooc](https://devopswithdocker.com/) for additional credits – and learning.

### Operational

1. **Centralised Source code management** happens in [Universitys' instance of Gitlab](https://gitlab.jyu.fi). Similar to more popular Github, it provides and web interface for common management operations and centralised location for "main" code repository.

2. **Tests** are managed by gitlab, and run on cloud infrastructure.

3. **Infrastructure** is from [Microsoft Azure](https://portal.azure.com) - for the simple reason of getting it "[free](https://azure.microsoft.com/en-us/free/students/)". Tooling used is relatively standardized and can be used with Google Cloud, IBM Cloud, Amazon Web Services and such.
