# Creating a gitlab pipeline

Gitlab pipeline is defined in project `.gitlab-ci.yml` file <https://docs.gitlab.com/ee/ci/>.

File is easy to break - yaml is not a great syntax - and instead of directly editing file in vscode, using gitlab CI/CD editor UI is recommended, as it provides a small syntaxt checker and linter.

By default TJTS5901 course starts with only one stage, which takes care of building and pushing image to cloud. New stages will be added as they become applicaple.

## Set up project pipeline

By forking default pipeline, it should be somewhat ready - dending that the supporting infrastructure is set up (runner, container registry, and web app). If you're using kubernetes, please make necessary changes to use docker-in-docker. See [`docs/tjts5901/azure-runner/gitlab-ci-dind.yml`](../azure-runner/gitlab-ci-dind.yml) for additional `services` and `varibles` sections.

It just need project specific variables.

1. In [gitlab](https://gitlab.jyu.fi) go into your project **Settings** → **CI/CD**.

2. Expand the **Variables** section, and add three new variables:
    1. `DOCKER_REGISTRY`:       This is the registry address, can be found from azure "Container registry" overview page, titled **Login server** (example `<name>.azurecr.io`)
    2. `DOCKER_REGISTRY_USER`:  If the container registry access admin user is enabled, this is same as registry name -- the `<name>` part from previous setting.
    3. `DOCKER_REGISTRY_PASS`:  If the container registry access admin user is enable, same page supplies two passwords. Use one.
 
    Please note that `DOCKER_REGISTRY_PASS` variable shold be protected. By default "main" branch is protected - meaning only merges to main branch can access this variable.
    ![Gitlab variables ](gitlab-variables.png)

3. Modify pipeline to use correct docker address for tagging.
    * In gitlab project, select from left menu **CI/CD** → **Editor**
    * Find the "`## tag build` section, and change `- docker tag dogmap tjts5901.azurecr.io/dogmap:latest` to `- docker tag dogmap $DOCKER_REGISTRY/dogmap:latest` (see commit 820b0b55341d0fa33d139f9ee9bb10bcaab12cc7)

    Change should trigger a new build operation. From **CI/CD** → **Jobs** you should be able to see running job, and view build details.
